<script setup>
    import { ref, onMounted } from 'vue'
    import UserCreateModal from '@/components/UserCreateModal.vue';
    import store from '@/store';
    import { HttpReq } from '@/utilies/httpRequest';

    const users = ref([])
    const refUserCreateModal = ref(null)
    const headers = [
        {
            text: 'Nombre',
            align: 'start',
            value: 'name'
        },
        {
            text: 'Usuario',
            value: 'username'
        },
        {
            text: 'Rol',
            value: 'roleName'
        },
        {
            text: 'Actions',
            value: 'actions',
            sortable: false 
        }
    ]

    onMounted(() => {
        getDataApi()
    })

    async function getDataApi() {
        let resp = await fakeApiCall()
        users.value = resp.map(item => {
            return {
                id: item.id,
                username: item.username,
                name: item.name,
                roleName: item.role.name,
                role: item.role
            }
        })
        console.log("users: ", users.value)
    }

    function addUser() {
        refUserCreateModal.value.postModal()
    }

    function editUser(item) {
        refUserCreateModal.value.putModal({...item})
        console.log("item edit: ", item)
    }

    async function deleteUser(data) {
        let resp = {
            status: 200
        }
        if(resp.status == 200) {
            users.value = users.value.filter(item => {
                return item.id != data.id
            })

            store.dispatch('openModal', {
                title: "Eliminar usuario",
                body: "El usuario se ha eliminado sastifactoriamente",
                type: 0
            })
        }
    }

    function responsePost(item) {
        users.value.push({
            id: item.idD,
            name: item.nameD,
            username: item.usernameD,
            roleName: "ROLE_ADMIN",
            role: item.role
        })
        
    }

    function responsePut(data) {
        let index = users.value.findIndex(item => item.id == data.idD)
        users.value[index].name = data.nameD
        users.value[index].role = {
            id: data.role.idD,
            name: data.role.nameD
        }
        users.value[index].username = data.usernameD
        console.log("item Put: ", index)
        console.log("users: ", users.value)
        console.log("data: ", data)
    }
    /**
     * Api fake
     */

    function fakeApiCall() {
        return new Promise((resolve, reject) => {
            let items = getUsers()

            setTimeout(() => {
                resolve(
                    items
                )
            }, 1000)

        })
    }

    function getUsers() {
        return [
            {
                id: 12343,
                username: "pepito",
                name: "Jaime Perez",
                role: {
                    id: "636c276b97aed3f61e26bf4d",
                    name: "ROLE_ADMIN"
                }
            }, 
            {
                id: 987654,
                username: "popi",
                name: "Lorena Cuca",
                role: {
                    id: "636c237297aed3f61e26bf4b",
                    name: "ROLE_OPERATOR"
                }
            }
        ]
    }
</script>

<template>
    <!-- eslint-disable -->
    <div>
        <!--Modals-->
        <UserCreateModal ref="refUserCreateModal" @addUser="responsePost" @editUser="responsePut"/>

        <v-row>
            <v-col cols="12">
                <v-btn
                    depressed
                    color="primary"
                    @click="addUser"
                >
                    Agregar Usuario
                </v-btn>
            </v-col>
        </v-row>
        <v-row>
            <v-col cols="12">
                <v-data-table
                    :headers="headers"
                    :items="users"
                    class="elevation-1"
                >
            
                    <template v-slot:item.actions="{item}">
                        <v-icon
                            small
                            class="mr-2"
                            @click="editUser(item)"
                        >
                            mdi-pencil
                        </v-icon>
                        <v-icon
                            small
                            @click="deleteUser(item)"
                        >
                            mdi-delete
                        </v-icon>
                    </template>
            
                </v-data-table>
            </v-col>
        </v-row>

    </div>

</template>

<style>

</style>